Index: serefpolicy-contrib-20140730/apache.if
===================================================================
--- serefpolicy-contrib-20140730.orig/apache.if
+++ serefpolicy-contrib-20140730/apache.if
@@ -1,9 +1,9 @@
-## <summary>Various web servers.</summary>
+## <summary>Apache web server</summary>
 
 ########################################
 ## <summary>
-##	Create a set of derived types for
-##	httpd web content.
+##	Create a set of derived types for apache
+##	web content.
 ## </summary>
 ## <param name="prefix">
 ##	<summary>
@@ -13,119 +13,126 @@
 #
 template(`apache_content_template',`
 	gen_require(`
-		attribute httpdcontent, httpd_exec_scripts, httpd_script_exec_type;
-		attribute httpd_script_domains, httpd_htaccess_type;
-		attribute httpd_rw_content, httpd_ra_content;
+		attribute httpd_exec_scripts, httpd_script_exec_type;
 		type httpd_t, httpd_suexec_t;
+		attribute httpd_script_type, httpd_content_type;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
-	## <desc>
-	##	<p>
-	##	Determine whether the script domain can
-	##	modify public files used for public file
-	##	transfer services. Directories/Files must
-	##	be labeled public_content_rw_t.
-	##	</p>
-	## </desc>
-	gen_tunable(allow_httpd_$1_script_anon_write, false)
-
-	type httpd_$1_content_t, httpdcontent; # customizable
-	typealias httpd_$1_content_t alias httpd_$1_script_ro_t;
-	files_type(httpd_$1_content_t)
-
-	type httpd_$1_htaccess_t, httpd_htaccess_type; # customizable;
-	files_type(httpd_$1_htaccess_t)
-
-	type httpd_$1_script_t, httpd_script_domains;
-	domain_type(httpd_$1_script_t)
-	role system_r types httpd_$1_script_t;
-
-	type httpd_$1_script_exec_t, httpd_script_exec_type; # customizable;
-	corecmd_shell_entry_type(httpd_$1_script_t)
-	domain_entry_file(httpd_$1_script_t, httpd_$1_script_exec_t)
-
-	type httpd_$1_rw_content_t, httpdcontent, httpd_rw_content; # customizable
-	typealias httpd_$1_rw_content_t alias { httpd_$1_script_rw_t httpd_$1_content_rw_t };
-	files_type(httpd_$1_rw_content_t)
-
-	type httpd_$1_ra_content_t, httpdcontent, httpd_ra_content; # customizable
-	typealias httpd_$1_ra_content_t alias { httpd_$1_script_ra_t httpd_$1_content_ra_t };
-	files_type(httpd_$1_ra_content_t)
-
-	########################################
-	#
-	# Policy
-	#
-
-	can_exec(httpd_$1_script_t, httpd_$1_script_exec_t)
-
-	allow httpd_$1_script_t httpd_$1_ra_content_t:dir { list_dir_perms add_entry_dir_perms setattr_dir_perms };
-	allow httpd_$1_script_t httpd_$1_ra_content_t:file { append_file_perms read_file_perms create_file_perms setattr_file_perms };
-	allow httpd_$1_script_t httpd_$1_ra_content_t:lnk_file read_lnk_file_perms;
-
-	allow httpd_$1_script_t { httpd_$1_content_t httpd_$1_script_exec_t }:dir list_dir_perms;
-	allow httpd_$1_script_t httpd_$1_content_t:file read_file_perms;
-	allow httpd_$1_script_t { httpd_$1_content_t httpd_$1_script_exec_t }:lnk_file read_lnk_file_perms;
-
-	manage_dirs_pattern(httpd_$1_script_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-	manage_files_pattern(httpd_$1_script_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-	manage_lnk_files_pattern(httpd_$1_script_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-	manage_fifo_files_pattern(httpd_$1_script_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-	manage_sock_files_pattern(httpd_$1_script_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-	files_tmp_filetrans(httpd_$1_script_t, httpd_$1_rw_content_t, { dir file lnk_file sock_file fifo_file })
-
-	allow { httpd_t httpd_suexec_t } httpd_$1_content_t:dir list_dir_perms;
-	allow { httpd_t httpd_suexec_t } { httpd_$1_content_t httpd_$1_htaccess_t }:file read_file_perms;
-	allow { httpd_t httpd_suexec_t } httpd_$1_content_t:lnk_file read_lnk_file_perms;
+	#This type is for webpages
+	type $1_content_t; # customizable;
+	typeattribute $1_content_t httpd_content_type;
+	typealias $1_content_t alias httpd_$1_script_ro_t;
+	files_type($1_content_t)
+
+	# This type is used for .htaccess files
+	type $1_htaccess_t, httpd_content_type; # customizable;
+	typeattribute $1_htaccess_t httpd_content_type;
+	files_type($1_htaccess_t)
+
+	# Type that CGI scripts run as
+	type $1_script_t,	httpd_script_type;
+	domain_type($1_script_t)
+	role system_r types $1_script_t;
+
+	kernel_read_system_state($1_script_t)
+
+	# This type is used for executable scripts files
+	type $1_script_exec_t, httpd_script_exec_type; # customizable;
+	typeattribute $1_script_exec_t httpd_content_type;
+	domain_entry_file($1_script_t, $1_script_exec_t)
+
+	type $1_rw_content_t; # customizable
+	typeattribute $1_rw_content_t httpd_content_type;
+	typealias $1_rw_content_t alias { $1_script_rw_t };
+	files_type($1_rw_content_t)
+
+	type $1_ra_content_t, httpd_content_type; # customizable
+	typeattribute $1_ra_content_t httpd_content_type;
+	typealias $1_ra_content_t alias { $1_script_ra_t $1_content_ra_t };
+	files_type($1_ra_content_t)
+
+	# Allow the script process to search the cgi directory, and users directory
+	allow $1_script_t $1_content_t:dir search_dir_perms;
+
+	can_exec($1_script_t, $1_script_exec_t)
+	allow $1_script_t $1_script_exec_t:dir list_dir_perms;
+	allow $1_script_t $1_ra_content_t:dir { list_dir_perms add_entry_dir_perms };
+	read_files_pattern($1_script_t, $1_ra_content_t, $1_ra_content_t)
+	append_files_pattern($1_script_t, $1_ra_content_t, $1_ra_content_t)
+	create_files_pattern($1_script_t, $1_ra_content_t, $1_ra_content_t)
+	read_lnk_files_pattern($1_script_t, $1_ra_content_t, $1_ra_content_t)
+
+	allow $1_script_t $1_content_t:dir list_dir_perms;
+	read_files_pattern($1_script_t, $1_content_t, $1_content_t)
+	read_lnk_files_pattern($1_script_t, $1_content_t, $1_content_t)
+
+	manage_dirs_pattern($1_script_t, $1_rw_content_t, $1_rw_content_t)
+	manage_files_pattern($1_script_t, $1_rw_content_t, $1_rw_content_t)
+	manage_lnk_files_pattern($1_script_t, $1_rw_content_t, $1_rw_content_t)
+	manage_fifo_files_pattern($1_script_t, $1_rw_content_t, $1_rw_content_t)
+	manage_sock_files_pattern($1_script_t, $1_rw_content_t, $1_rw_content_t)
 
-	tunable_policy(`allow_httpd_$1_script_anon_write',`
-		miscfiles_manage_public_files(httpd_$1_script_t)
-	')
+	allow $1_script_t httpd_t:unix_stream_socket { getattr read write };
 
+	# Allow the web server to run scripts and serve pages
 	tunable_policy(`httpd_builtin_scripting',`
-		manage_dirs_pattern(httpd_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-		manage_files_pattern(httpd_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-		manage_fifo_files_pattern(httpd_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-		manage_lnk_files_pattern(httpd_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-		manage_sock_files_pattern(httpd_t, httpd_$1_rw_content_t, httpd_$1_rw_content_t)
-
-		allow httpd_t httpd_$1_ra_content_t:dir { list_dir_perms add_entry_dir_perms setattr_dir_perms };
-		allow httpd_t httpd_$1_ra_content_t:file { append_file_perms read_file_perms create_file_perms setattr_file_perms };
-		allow httpd_t httpd_$1_ra_content_t:lnk_file read_lnk_file_perms;
-	')
+		manage_dirs_pattern(httpd_t, $1_rw_content_t, $1_rw_content_t)
+		manage_files_pattern(httpd_t, $1_rw_content_t, $1_rw_content_t)
+		manage_lnk_files_pattern(httpd_t, $1_rw_content_t, $1_rw_content_t)
+		rw_sock_files_pattern(httpd_t, $1_rw_content_t, $1_rw_content_t)
+
+		allow httpd_t $1_ra_content_t:dir { add_entry_dir_perms };
+		read_files_pattern(httpd_t, $1_ra_content_t, $1_ra_content_t)
+		append_files_pattern(httpd_t, $1_ra_content_t, $1_ra_content_t)
+		create_files_pattern(httpd_t, $1_ra_content_t, $1_ra_content_t)
+		read_lnk_files_pattern(httpd_t, $1_ra_content_t, $1_ra_content_t)
 
-	tunable_policy(`httpd_builtin_scripting && httpd_tmp_exec',`
-		can_exec(httpd_t, httpd_$1_rw_content_t)
 	')
 
 	tunable_policy(`httpd_enable_cgi',`
-		allow httpd_$1_script_t httpd_$1_script_exec_t:file entrypoint;
-		domtrans_pattern({ httpd_t httpd_suexec_t httpd_exec_scripts }, httpd_$1_script_exec_t, httpd_$1_script_t)
-	')
+		allow $1_script_t $1_script_exec_t:file entrypoint;
 
-	tunable_policy(`httpd_enable_cgi && httpd_tmp_exec',`
-		can_exec(httpd_$1_script_t, httpd_$1_rw_content_t)
-	')
+		domtrans_pattern(httpd_suexec_t, $1_script_exec_t, $1_script_t)
 
-	tunable_policy(`httpd_enable_cgi && httpd_unified',`
-		allow httpd_$1_script_t { httpd_$1_content_t httpd_$1_ra_content_t }:file entrypoint;
-		allow httpd_$1_script_t { httpd_$1_content_t httpd_$1_ra_content_t }:dir manage_dir_perms;
-		allow httpd_$1_script_t { httpd_$1_content_t httpd_$1_ra_content_t }:file manage_file_perms;
-	')
+		# privileged users run the script:
+		domtrans_pattern(httpd_exec_scripts, $1_script_exec_t, $1_script_t)
+
+		allow httpd_exec_scripts $1_script_exec_t:file read_file_perms;
 
-	tunable_policy(`httpd_enable_cgi && httpd_unified && httpd_builtin_scripting',`
-		filetrans_pattern(httpd_t, httpd_$1_content_t, httpd_$1_rw_content_t, { file dir fifo_file lnk_file sock_file })
+		# apache runs the script:
+		domtrans_pattern(httpd_t, $1_script_exec_t, $1_script_t)
+		allow httpd_t $1_script_t:unix_dgram_socket sendto;
 	')
 ')
 
 ########################################
 ## <summary>
-##	Role access for apache.
+##	Create a set of derived types for apache
+##	web content.
+## </summary>
+## <param name="prefix">
+##	<summary>
+##	The prefix to be used for deriving new type names.
+##	</summary>
+## </param>
+## <param name="oldprefix">
+##	<summary>
+##	The prefix to be used for deriving old type names.
+##	</summary>
+## </param>
+#
+template(`apache_content_alias_template',`
+	typealias $1_htaccess_t alias httpd_$2_htaccess_t;
+	typealias $1_script_t alias httpd_$2_script_t;
+	typealias $1_script_exec_t alias httpd_$2_script_exec_t;
+	typealias $1_content_t alias httpd_$2_content_t;
+	typealias $1_rw_content_t alias httpd_$2_script_rw_content_t;
+	typealias $1_ra_content_t alias httpd_$2_script_ra_content_t;
+')
+
+########################################
+## <summary>
+##	Role access for apache
 ## </summary>
 ## <param name="role">
 ##	<summary>
@@ -134,47 +141,61 @@ template(`apache_content_template',`
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
 #
 interface(`apache_role',`
 	gen_require(`
 		attribute httpdcontent;
-		type httpd_user_content_t, httpd_user_htaccess_t;
-		type httpd_user_script_t, httpd_user_script_exec_t;
-		type httpd_user_ra_content_t, httpd_user_rw_content_t;
+		type httpd_user_content_t, httpd_user_htaccess_t, httpd_user_script_t;
+		type httpd_user_ra_content_t, httpd_user_rw_content_t, httpd_user_script_exec_t;
 	')
 
 	role $1 types httpd_user_script_t;
 
-	allow $2 httpd_user_htaccess_t:file { manage_file_perms relabel_file_perms };
+	allow $2 httpd_user_htaccess_t:file { manage_file_perms relabelto relabelfrom };
+
+	manage_dirs_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	manage_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	manage_lnk_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	relabel_dirs_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	relabel_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	relabel_lnk_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+
+	manage_dirs_pattern($2, httpd_user_ra_content_t, httpd_user_ra_content_t)
+	manage_files_pattern($2, httpd_user_ra_content_t, httpd_user_ra_content_t)
+	manage_lnk_files_pattern($2, httpd_user_ra_content_t, httpd_user_ra_content_t)
+	relabel_dirs_pattern($2, httpd_user_ra_content_t, httpd_user_ra_content_t)
+	relabel_files_pattern($2, httpd_user_ra_content_t, httpd_user_ra_content_t)
+	relabel_lnk_files_pattern($2, httpd_user_ra_content_t, httpd_user_ra_content_t)
+
+	manage_dirs_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	manage_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	manage_lnk_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	relabel_dirs_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	relabel_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+	relabel_lnk_files_pattern($2, httpd_user_content_t, httpd_user_content_t)
+
+	manage_dirs_pattern($2, httpd_user_rw_content_t, httpd_user_rw_content_t)
+	manage_files_pattern($2, httpd_user_rw_content_t, httpd_user_rw_content_t)
+	manage_lnk_files_pattern($2, httpd_user_rw_content_t, httpd_user_rw_content_t)
+	relabel_dirs_pattern($2, httpd_user_rw_content_t, httpd_user_rw_content_t)
+	relabel_files_pattern($2, httpd_user_rw_content_t, httpd_user_rw_content_t)
+	relabel_lnk_files_pattern($2, httpd_user_rw_content_t, httpd_user_rw_content_t)
+
+	manage_dirs_pattern($2, httpd_user_script_exec_t, httpd_user_script_exec_t)
+	manage_files_pattern($2, httpd_user_script_exec_t, httpd_user_script_exec_t)
+	manage_lnk_files_pattern($2, httpd_user_script_exec_t, httpd_user_script_exec_t)
+	relabel_dirs_pattern($2, httpd_user_script_exec_t, httpd_user_script_exec_t)
+	relabel_files_pattern($2, httpd_user_script_exec_t, httpd_user_script_exec_t)
+	relabel_lnk_files_pattern($2, httpd_user_script_exec_t, httpd_user_script_exec_t)
 
-	allow $2 httpd_user_content_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 httpd_user_content_t:file { manage_file_perms relabel_file_perms };
-	allow $2 httpd_user_content_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-
-	allow $2 httpd_user_ra_content_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 httpd_user_ra_content_t:file { manage_file_perms relabel_file_perms };
-	allow $2 httpd_user_ra_content_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-
-	allow $2 httpd_user_rw_content_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 httpd_user_rw_content_t:file { manage_file_perms relabel_file_perms };
-	allow $2 httpd_user_rw_content_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-
-	allow $2 httpd_user_script_exec_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 httpd_user_script_exec_t:file { manage_file_perms relabel_file_perms };
-	allow $2 httpd_user_script_exec_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-
-	userdom_user_home_dir_filetrans($2, httpd_user_content_t, dir, "public_html")
-	userdom_user_home_dir_filetrans($2, httpd_user_content_t, dir, "web")
-	userdom_user_home_dir_filetrans($2, httpd_user_content_t, dir, "www")
-
-	filetrans_pattern($2, httpd_user_content_t, httpd_user_htaccess_t, file, ".htaccess")
-	filetrans_pattern($2, httpd_user_content_t, httpd_user_script_exec_t, dir, "cgi-bin")
-	filetrans_pattern($2, httpd_user_content_t, httpd_user_ra_content_t, dir, "logs")
+	apache_exec_modules($2)
+	apache_filetrans_home_content($2)
 
 	tunable_policy(`httpd_enable_cgi',`
+		# If a user starts a script by hand it gets the proper context
 		domtrans_pattern($2, httpd_user_script_exec_t, httpd_user_script_t)
 	')
 
@@ -185,7 +206,7 @@ interface(`apache_role',`
 
 ########################################
 ## <summary>
-##	Read user httpd script executable files.
+##	Read httpd user scripts executables.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -205,7 +226,7 @@ interface(`apache_read_user_scripts',`
 
 ########################################
 ## <summary>
-##	Read user httpd content.
+##	Read user web content.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -225,7 +246,7 @@ interface(`apache_read_user_content',`
 
 ########################################
 ## <summary>
-##	Execute httpd with a domain transition.
+##	Transition to apache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -242,27 +263,47 @@ interface(`apache_domtrans',`
 	domtrans_pattern($1, httpd_exec_t, httpd_t)
 ')
 
-########################################
+######################################
 ## <summary>
-##	Execute httpd server in the httpd domain.
+##	Allow the specified domain to execute apache
+##	in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`apache_initrc_domtrans',`
+interface(`apache_exec',`
 	gen_require(`
-		type httpd_initrc_exec_t;
+		type httpd_exec_t;
 	')
 
-	init_labeled_script_domtrans($1, httpd_initrc_exec_t)
+	can_exec($1, httpd_exec_t)
+')
+
+######################################
+## <summary>
+##	Allow the specified domain to execute apache suexec
+##	in the caller domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`apache_exec_suexec',`
+	gen_require(`
+		type httpd_suexec_exec_t;
+	')
+
+	can_exec($1, httpd_suexec_exec_t)
 ')
 
 #######################################
 ## <summary>
-##	Send generic signals to httpd.
+##	Send a generic signal to apache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -280,7 +321,7 @@ interface(`apache_signal',`
 
 ########################################
 ## <summary>
-##	Send null signals to httpd.
+##	Send a null signal to apache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -298,7 +339,7 @@ interface(`apache_signull',`
 
 ########################################
 ## <summary>
-##	Send child terminated signals to httpd.
+##	Send a SIGCHLD signal to apache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -316,8 +357,7 @@ interface(`apache_sigchld',`
 
 ########################################
 ## <summary>
-##	Inherit and use file descriptors
-##	from httpd.
+##	Inherit and use file descriptors from Apache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -335,8 +375,8 @@ interface(`apache_use_fds',`
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write httpd unnamed pipes.
+##	Do not audit attempts to read and write Apache
+##	unnamed pipes.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -349,13 +389,13 @@ interface(`apache_dontaudit_rw_fifo_file
 		type httpd_t;
 	')
 
-	dontaudit $1 httpd_t:fifo_file rw_fifo_file_perms;
+	dontaudit $1 httpd_t:fifo_file rw_inherited_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write httpd unix domain stream sockets.
+##	Do not audit attempts to read and write Apache
+##	unix domain stream sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -373,8 +413,8 @@ interface(`apache_dontaudit_rw_stream_so
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write httpd TCP sockets.
+##	Do not audit attempts to read and write Apache
+##	TCP sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -392,123 +432,7 @@ interface(`apache_dontaudit_rw_tcp_socke
 
 ########################################
 ## <summary>
-##	Read all appendable content
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`apache_read_all_ra_content',`
-	gen_require(`
-		attribute httpd_ra_content;
-	')
-
-	read_files_pattern($1, httpd_ra_content, httpd_ra_content)
-	read_lnk_files_pattern($1, httpd_ra_content, httpd_ra_content)
-')
-
-########################################
-## <summary>
-##	Append to all appendable web content
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`apache_append_all_ra_content',`
-	gen_require(`
-		attribute httpd_ra_content;
-	')
-
-	append_files_pattern($1, httpd_ra_content, httpd_ra_content)
-')
-
-########################################
-## <summary>
-##	Read all read/write content
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`apache_read_all_rw_content',`
-	gen_require(`
-		attribute httpd_rw_content;
-	')
-
-	read_files_pattern($1, httpd_rw_content, httpd_rw_content)
-	read_lnk_files_pattern($1, httpd_rw_content, httpd_rw_content)
-')
-
-########################################
-## <summary>
-##	Manage all read/write content
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`apache_manage_all_rw_content',`
-	gen_require(`
-		attribute httpd_rw_content;
-	')
-
-	manage_dirs_pattern($1, httpd_rw_content, httpd_rw_content)
-	manage_files_pattern($1, httpd_rw_content, httpd_rw_content)
-	manage_lnk_files_pattern($1, httpd_rw_content, httpd_rw_content)
-')
-########################################
-## <summary>
-##	Read all web content.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`apache_read_all_content',`
-	gen_require(`
-		attribute httpdcontent, httpd_script_exec_type;
-	')
-
-	read_files_pattern($1, httpdcontent, httpdcontent)
-	read_lnk_files_pattern($1, httpdcontent, httpdcontent)
-
-	read_files_pattern($1, httpd_script_exec_type, httpd_script_exec_type)
-	read_lnk_files_pattern($1, httpd_script_exec_type, httpd_script_exec_type)
-')
-
-#######################################
-## <summary>
-##	Search all apache content.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`apache_search_all_content',`
-	gen_require(`
-		attribute httpdcontent;
-	')
-
-	allow $1 httpdcontent:dir search_dir_perms;
-')
-
-########################################
-## <summary>
-##	Create, read, write, and delete
-##	all httpd content.
+##	Create, read, write, and delete all web content.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -533,7 +457,8 @@ interface(`apache_manage_all_content',`
 
 ########################################
 ## <summary>
-##	Set attributes httpd cache directories.
+##	Allow domain to  set the attributes
+##	of the APACHE cache directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -551,7 +476,8 @@ interface(`apache_setattr_cache_dirs',`
 
 ########################################
 ## <summary>
-##	List httpd cache directories.
+##	Allow the specified domain to list
+##	Apache cache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -569,7 +495,8 @@ interface(`apache_list_cache',`
 
 ########################################
 ## <summary>
-##	Read and write httpd cache files.
+##	Allow the specified domain to read
+##	and write Apache cache files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -587,7 +514,8 @@ interface(`apache_rw_cache_files',`
 
 ########################################
 ## <summary>
-##	Delete httpd cache directories.
+##	Allow the specified domain to delete
+##	Apache cache dirs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -605,7 +533,8 @@ interface(`apache_delete_cache_dirs',`
 
 ########################################
 ## <summary>
-##	Delete httpd cache files.
+##	Allow the specified domain to delete
+##	Apache cache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -623,49 +552,51 @@ interface(`apache_delete_cache_files',`
 
 ########################################
 ## <summary>
-##	Read httpd configuration files.
+##	Allow the specified domain to search
+##	apache configuration dirs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`apache_read_config',`
+interface(`apache_search_config',`
 	gen_require(`
 		type httpd_config_t;
 	')
 
 	files_search_etc($1)
-	allow $1 httpd_config_t:dir list_dir_perms;
-	read_files_pattern($1, httpd_config_t, httpd_config_t)
-	read_lnk_files_pattern($1, httpd_config_t, httpd_config_t)
+	allow $1 httpd_config_t:dir search_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Search httpd configuration directories.
+##	Allow the specified domain to read
+##	apache configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
-interface(`apache_search_config',`
+interface(`apache_read_config',`
 	gen_require(`
 		type httpd_config_t;
 	')
 
 	files_search_etc($1)
-	allow $1 httpd_config_t:dir search_dir_perms;
+	allow $1 httpd_config_t:dir list_dir_perms;
+	read_files_pattern($1, httpd_config_t, httpd_config_t)
+	read_lnk_files_pattern($1, httpd_config_t, httpd_config_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	httpd configuration files.
+##	Allow the specified domain to manage
+##	apache configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -686,8 +617,8 @@ interface(`apache_manage_config',`
 
 ########################################
 ## <summary>
-##	Execute the Apache helper program
-##	with a domain transition.
+##	Execute the Apache helper program with
+##	a domain transition.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -724,16 +655,38 @@ interface(`apache_domtrans_helper',`
 #
 interface(`apache_run_helper',`
 	gen_require(`
-		attribute_role httpd_helper_roles;
+		type httpd_helper_t;
 	')
 
 	apache_domtrans_helper($1)
-	roleattribute $2 httpd_helper_roles;
+	role $2 types httpd_helper_t;
+')
+
+########################################
+## <summary>
+##	dontaudit attempts to read
+##	apache log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`apache_dontaudit_read_log',`
+	gen_require(`
+		type httpd_log_t;
+	')
+
+	dontaudit $1 httpd_log_t:file read_file_perms;
+	dontaudit $1 httpd_log_t:lnk_file read_lnk_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read httpd log files.
+##	Allow the specified domain to read
+##	apache log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -755,7 +708,8 @@ interface(`apache_read_log',`
 
 ########################################
 ## <summary>
-##	Append httpd log files.
+##	Allow the specified domain to append
+##	to apache log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -773,10 +727,29 @@ interface(`apache_append_log',`
 	append_files_pattern($1, httpd_log_t, httpd_log_t)
 ')
 
+#######################################
+## <summary>
+##  Allow the specified domain to write
+##  to apache log files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`apache_write_log',`
+    gen_require(`
+        type httpd_log_t;
+    ')
+
+	allow $1 httpd_log_t:file write;
+')
+
 ########################################
 ## <summary>
-##	Do not audit attempts to append
-##	httpd log files.
+##	Do not audit attempts to append to the
+##	Apache logs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -794,8 +767,8 @@ interface(`apache_dontaudit_append_log',
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	httpd log files.
+##	Allow the specified domain to manage
+##	to apache var lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -803,20 +776,21 @@ interface(`apache_dontaudit_append_log',
 ##	</summary>
 ## </param>
 #
-interface(`apache_manage_log',`
+interface(`apache_manage_lib',`
 	gen_require(`
-		type httpd_log_t;
+		type httpd_var_lib_t;
 	')
 
-	logging_search_logs($1)
-	manage_dirs_pattern($1, httpd_log_t, httpd_log_t)
-	manage_files_pattern($1, httpd_log_t, httpd_log_t)
-	read_lnk_files_pattern($1, httpd_log_t, httpd_log_t)
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, httpd_var_lib_t, httpd_var_lib_t)
+	manage_files_pattern($1, httpd_var_lib_t, httpd_var_lib_t)
+	read_lnk_files_pattern($1, httpd_var_lib_t, httpd_var_lib_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Write apache log files.
+##	Allow the specified domain to manage
+##	to apache log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -824,19 +798,21 @@ interface(`apache_manage_log',`
 ##	</summary>
 ## </param>
 #
-interface(`apache_write_log',`
+interface(`apache_manage_log',`
 	gen_require(`
 		type httpd_log_t;
 	')
 
 	logging_search_logs($1)
-	write_files_pattern($1, httpd_log_t, httpd_log_t)
+	manage_dirs_pattern($1, httpd_log_t, httpd_log_t)
+	manage_files_pattern($1, httpd_log_t, httpd_log_t)
+	read_lnk_files_pattern($1, httpd_log_t, httpd_log_t)
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to search
-##	httpd module directories.
+##	Do not audit attempts to search Apache
+##	module directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -854,7 +830,8 @@ interface(`apache_dontaudit_search_modul
 
 ########################################
 ## <summary>
-##	List httpd module directories.
+##	Allow the specified domain to read
+##	the apache module directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -862,17 +839,19 @@ interface(`apache_dontaudit_search_modul
 ##	</summary>
 ## </param>
 #
-interface(`apache_list_modules',`
+interface(`apache_read_modules',`
 	gen_require(`
 		type httpd_modules_t;
 	')
 
-	allow $1 httpd_modules_t:dir list_dir_perms;
+	read_files_pattern($1, httpd_modules_t, httpd_modules_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute httpd module files.
+##	Allow the specified domain to list
+##	the contents of the apache modules
+##	directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -880,19 +859,19 @@ interface(`apache_list_modules',`
 ##	</summary>
 ## </param>
 #
-interface(`apache_exec_modules',`
+interface(`apache_list_modules',`
 	gen_require(`
 		type httpd_modules_t;
 	')
 
 	allow $1 httpd_modules_t:dir list_dir_perms;
-	allow $1 httpd_modules_t:lnk_file read_lnk_file_perms;
-	can_exec($1, httpd_modules_t)
+	read_lnk_files_pattern($1, httpd_modules_t, httpd_modules_t)
 ')
 
 ########################################
 ## <summary>
-##	Read httpd module files.
+##	Allow the specified domain to execute
+##	apache modules.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -900,19 +879,19 @@ interface(`apache_exec_modules',`
 ##	</summary>
 ## </param>
 #
-interface(`apache_read_module_files',`
+interface(`apache_exec_modules',`
 	gen_require(`
 		type httpd_modules_t;
 	')
 
-	libs_search_lib($1)
-	read_files_pattern($1, httpd_modules_t, httpd_modules_t)
+	allow $1 httpd_modules_t:dir list_dir_perms;
+	allow $1 httpd_modules_t:lnk_file read_lnk_file_perms;
+	can_exec($1, httpd_modules_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute a domain transition to
-##	run httpd_rotatelogs.
+##	Execute a domain transition to run httpd_rotatelogs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
